/*
  rdesktop: A Remote Desktop Protocol client.
  Amiga front-end etc
  Copyright (C) Martin Blom 2004-2005
            (C) Michal Zukowski 2013
*/	

#include <string.h>
#include <proto/locale.h>
#include "country_codes.h"

int getkeylayout(int keylayout)
{ 
	int ret=keylayout;
	struct Locale* locale;

	if((locale = OpenLocale(NULL)))
	{
		struct ContryCodes* cc = amiga_country_codes;
		char code[4];

		code[0] = (locale->loc_CountryCode >> 24) & 255;
		code[1] = (locale->loc_CountryCode >> 16) & 255;
		code[2] = (locale->loc_CountryCode >>  8) & 255;
		code[3] = (locale->loc_CountryCode >>  0) & 255;

		for(cc = amiga_country_codes; cc->Country != NULL; ++cc)
		{
			if(strcmp(code, (const char *)cc->Alpha3) == 0)
			{
				ret = cc->WindowsLocaleCode;
				goto got_it;
			}
		}

		for(cc = amiga_country_codes; cc->Country != NULL; ++cc)
		{
			if(strcmp(code, (const char *)cc->DistinguishingSign) == 0)
			{
				ret = cc->WindowsLocaleCode;
				goto got_it;
			}
		}

		for(cc = amiga_country_codes; cc->Country != NULL; ++cc)
		{
			if(strcmp(code, (const char *)cc->Alpha2) == 0)
			{
				ret = cc->WindowsLocaleCode;
				goto got_it;
			}
		}

		for(cc = amiga_country_codes; cc->Country != NULL; ++cc)
		{
			if(strcmp(code, (const char *) cc->Extra) == 0)
			{
				ret = cc->WindowsLocaleCode;
				goto got_it;
			}
		}

got_it:
		CloseLocale(locale);
	}
	return keylayout;
}